<template>
    <div>
        <loading :active.sync="loading" is-full-page></loading>
        <md-dialog id="modal-login" :md-active.sync="classicModal" class="md-round classic-modal">
            <div class="md-layout md-alignment-top-right">
                <md-button class="md-icon-button" @click="loginModalHide">
                    <md-icon>clear</md-icon>
                </md-button>
            </div>

            <md-dialog-content v-if="resetPassword">
                <div class="text-align-center">
                    <p class="modal-title">RECUPERAR CONTRASEÑA</p>
                </div>

                <form novalidate>
                    <md-field :class="getValidationForgotPassClass('email')">
                        <!-- <md-icon>email</md-icon> -->
                        <label for="email">Ingrese su correo</label>
                        <md-input v-model="forgotPasswordForm.email" id="emailForgot" type="email"></md-input>
                        <span class="md-error">Correo requerido o invalido</span>
                    </md-field>
                    <md-button class="md-primary md-block md-radius" :disabled="loading" @click="validateForgotPasswordUser"
                        >RECUPERAR CONTRASEÑA</md-button
                    >
                </form>
            </md-dialog-content>

            <md-dialog-content v-else>
                <div class="text-align-center">
                    <p class="modal-title">¡BIENVENIDO!</p>
                    <p class="modal-title"><strong>INICIAR SESIÓN</strong></p>
                </div>

                <form novalidate>
                    <md-field :class="getValidationClass('email')">
                        <!-- <md-icon>email</md-icon> -->
                        <label for="email">Usuario</label>
                        <md-input v-model="form.email" id="email" type="email"></md-input>
                        <span class="md-error">Usuario requerido o invalido</span>
                    </md-field>
                    <md-field :class="getValidationClass('password')">
                        <!-- <md-icon>lock_outline</md-icon> -->
                        <label for="password">Contraseña</label>
                        <md-input v-model="form.password" type="password"></md-input>
                        <span class="md-error">Contraseña requerida o invalida</span>
                    </md-field>
                    <md-button class="md-primary md-block md-radius" :disabled="loading" @click="validateUser">INGRESAR</md-button>
                    <md-button class="md-dense" @click="resetPassword = true">*Olvide mi contraseña</md-button>
                </form>
            </md-dialog-content>
        </md-dialog>
    </div>
</template>

<script>
// import { LoginCard } from "../components";
import axios from 'axios';
import { Modal } from '../../components';
import { validationMixin } from 'vuelidate';
import { required, email, minLength } from 'vuelidate/lib/validators';

export default {
    name: 'login-section',
    bodyClass: 'login-modal',
    props: {
        showModal: {
            type: Boolean,
            default: false
        }
    },
    mixins: [validationMixin],
    components: {
        Modal
        // LoginCard
    },
    data() {
        return {
            form: {
                email: null,
                password: null
            },
            forgotPasswordForm: {
                email: null
            },
            endPoint: '/api/login',
            loading: false,
            resetPassword: false
        };
    },
    validations: {
        form: {
            email: {
                required,
                email
            },
            password: {
                required,
                minLength: minLength(3)
            }
        },
        forgotPasswordForm: {
            email: {
                required,
                email
            }
        }
    },
    computed: {
        classicModal() {
            return this.showModal;
        }
    },
    methods: {
        loginModalHide() {
            this.resetPassword = false;
            this.$v.form.$reset();
            this.$v.forgotPasswordForm.$reset();
            this.$emit('loginModalHide', event);
        },
        getValidationClass(fieldName) {
            const field = this.$v.form[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        getValidationForgotPassClass(fieldName) {
            const field = this.$v.forgotPasswordForm[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        clearForm() {
            this.$v.$reset();
            this.form.email = null;
            this.form.password = null;
        },
        validateUser() {
            this.$v.form.$touch();

            if (!this.$v.form.$invalid) {
                this.loginUser();
            }
        },
        validateForgotPasswordUser() {
            this.$v.forgotPasswordForm.$touch();

            if (!this.$v.forgotPasswordForm.$invalid) {
                this.forgotPasswordUser();
            }
        },
        loginUser() {
            this.loading = true;
            // var redirect = this.$auth.redirect()
            var app = this;
            this.$auth.login({
                data: {
                    email: app.form.email,
                    password: app.form.password
                },
                success: function() {
                    // handle redirection
                    this.loading = false;
                    app.success = true;
                    this.loginModalHide();
                    // const redirectTo = '/recursos'
                    // this.$router.push({
                    //     name: redirectTo
                    // })
                },
                error: function(res) {
                    this.loading = false;

                    if (res.response.status == 401) {
                        this.$root.ErrorMgs('Credenciales inválidas');
                    } else {
                        this.$root.ErrorMgs('No fue posible iniciar sesión');
                    }
                    app.has_error = true;
                    app.error = res.response.data.error;
                },
                rememberMe: true,
                fetchUser: true
            });
        },
        forgotPasswordUser() {
            this.loading = true;
            debugger;

            axios
                .post('api/forgotPassword', this.forgotPasswordForm)
                .then((response) => {
                    console.log(response);
                    this.loginModalHide();
                    if (response && response.data) {
                        this.$root.SuccessMgs('Se ha enviado correo');
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('No fue posible enviar el correo de recuperación');
                })
                .finally(() => {
                    this.loading = false;
                });
        }
    }
};
</script>

<style lang="scss" scoped>
@media screen and (min-width: 767px) {
    #modal-login {
        width: 600px;
    }

    .md-dialog {
        top: 35% !important;
    }
}

.modal-title {
    margin: 5px 0px;
    font-size: x-large;
}
</style>
